<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/ahash-0.7.6/src/random_state.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>random_state.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../ahash/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../ahash/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../ahash/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
</pre><pre class="rust"><code><span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;runtime-rng&quot;</span>, <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;compile-time-rng&quot;</span>, <span class="ident">test</span>))))]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::convert::Convert</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;specialize&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::BuildHasherExt</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(
    <span class="ident">all</span>(<span class="ident">any</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>), <span class="ident">target_feature</span> <span class="op">=</span> <span class="string">&quot;aes&quot;</span>, <span class="ident">not</span>(<span class="ident">miri</span>)),
    <span class="ident">all</span>(<span class="ident">any</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;aarch64&quot;</span>), <span class="ident">target_feature</span> <span class="op">=</span> <span class="string">&quot;crypto&quot;</span>, <span class="ident">not</span>(<span class="ident">miri</span>), <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;stdsimd&quot;</span>)
))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::aes_hash</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">any</span>(
    <span class="ident">all</span>(<span class="ident">any</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>), <span class="ident">target_feature</span> <span class="op">=</span> <span class="string">&quot;aes&quot;</span>, <span class="ident">not</span>(<span class="ident">miri</span>)),
    <span class="ident">all</span>(<span class="ident">any</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;aarch64&quot;</span>), <span class="ident">target_feature</span> <span class="op">=</span> <span class="string">&quot;crypto&quot;</span>, <span class="ident">not</span>(<span class="ident">miri</span>), <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;stdsimd&quot;</span>)
)))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::fallback_hash</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;compile-time-rng&quot;</span>, <span class="ident">any</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;runtime-rng&quot;</span>), <span class="ident">test</span>)))]</span>
<span class="kw">use</span> <span class="ident">const_random::const_random</span>;
<span class="kw">use</span> <span class="ident">core::any</span>::{<span class="ident">Any</span>, <span class="ident">TypeId</span>};
<span class="kw">use</span> <span class="ident">core::fmt</span>;
<span class="kw">use</span> <span class="ident">core::hash::BuildHasher</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;specialize&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident">core::hash::Hash</span>;
<span class="kw">use</span> <span class="ident">core::hash::Hasher</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">alloc</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">std</span> <span class="kw">as</span> <span class="ident">alloc</span>;

<span class="kw">use</span> <span class="ident">alloc::boxed::Box</span>;
<span class="kw">use</span> <span class="ident">core::sync::atomic</span>::{<span class="ident">AtomicUsize</span>, <span class="ident">Ordering</span>};
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;none&quot;</span>)))]</span>
<span class="kw">use</span> <span class="ident">once_cell::race::OnceBox</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(
    <span class="ident">all</span>(<span class="ident">any</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>), <span class="ident">target_feature</span> <span class="op">=</span> <span class="string">&quot;aes&quot;</span>, <span class="ident">not</span>(<span class="ident">miri</span>)),
    <span class="ident">all</span>(<span class="ident">any</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;aarch64&quot;</span>), <span class="ident">target_feature</span> <span class="op">=</span> <span class="string">&quot;crypto&quot;</span>, <span class="ident">not</span>(<span class="ident">miri</span>), <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;stdsimd&quot;</span>)
))]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::aes_hash</span>::<span class="kw-2">*</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">any</span>(
    <span class="ident">all</span>(<span class="ident">any</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>), <span class="ident">target_feature</span> <span class="op">=</span> <span class="string">&quot;aes&quot;</span>, <span class="ident">not</span>(<span class="ident">miri</span>)),
    <span class="ident">all</span>(<span class="ident">any</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;aarch64&quot;</span>), <span class="ident">target_feature</span> <span class="op">=</span> <span class="string">&quot;crypto&quot;</span>, <span class="ident">not</span>(<span class="ident">miri</span>), <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;stdsimd&quot;</span>)
)))]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::fallback_hash</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;none&quot;</span>)))]</span>
<span class="kw">static</span> <span class="ident">RAND_SOURCE</span>: <span class="ident">OnceBox</span><span class="op">&lt;</span><span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">RandomSource</span> <span class="op">+</span> <span class="ident">Send</span> <span class="op">+</span> <span class="ident">Sync</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">OnceBox::new</span>();

<span class="doccomment">/// A supplier of Randomness used for different hashers.</span>
<span class="doccomment">/// See [RandomState.set_random_source].</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">RandomSource</span> {

    <span class="kw">fn</span> <span class="ident">get_fixed_seeds</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> [[<span class="ident">u64</span>; <span class="number">4</span>]; <span class="number">2</span>];

    <span class="kw">fn</span> <span class="ident">gen_hasher_seed</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span>;

}

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">PI</span>: [<span class="ident">u64</span>; <span class="number">4</span>] <span class="op">=</span> [
    <span class="number">0x243f_6a88_85a3_08d3</span>,
    <span class="number">0x1319_8a2e_0370_7344</span>,
    <span class="number">0xa409_3822_299f_31d0</span>,
    <span class="number">0x082e_fa98_ec4e_6c89</span>,
];

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">const</span> <span class="ident">PI2</span>: [<span class="ident">u64</span>; <span class="number">4</span>] <span class="op">=</span> [
    <span class="number">0x4528_21e6_38d0_1377</span>,
    <span class="number">0xbe54_66cf_34e9_0c6c</span>,
    <span class="number">0xc0ac_29b7_c97c_50dd</span>,
    <span class="number">0x3f84_d5b5_b547_0917</span>,
];

<span class="kw">struct</span> <span class="ident">DefaultRandomSource</span> {
    <span class="ident">counter</span>: <span class="ident">AtomicUsize</span>,
}

<span class="kw">impl</span> <span class="ident">DefaultRandomSource</span> {
    <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="ident">DefaultRandomSource</span> {
        <span class="ident">DefaultRandomSource</span> {
            <span class="ident">counter</span>: <span class="ident">AtomicUsize::new</span>(<span class="kw-2">&amp;</span><span class="ident">PI</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="kw">_</span> <span class="kw">as</span> <span class="ident">usize</span>),
        }
    }

    <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="ident">DefaultRandomSource</span> {
        <span class="ident">DefaultRandomSource</span> {
            <span class="ident">counter</span>: <span class="ident">AtomicUsize::new</span>(<span class="ident">PI</span>[<span class="number">3</span>] <span class="kw">as</span> <span class="ident">usize</span>),
        }
    }
}

<span class="kw">impl</span> <span class="ident">RandomSource</span> <span class="kw">for</span> <span class="ident">DefaultRandomSource</span> {

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;runtime-rng&quot;</span>, <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;compile-time-rng&quot;</span>, <span class="ident">test</span>))))]</span>
    <span class="kw">fn</span> <span class="ident">get_fixed_seeds</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> [[<span class="ident">u64</span>; <span class="number">4</span>]; <span class="number">2</span>] {
        <span class="kw">static</span> <span class="ident">SEEDS</span>: <span class="ident">OnceBox</span><span class="op">&lt;</span>[[<span class="ident">u64</span>; <span class="number">4</span>]; <span class="number">2</span>]<span class="op">&gt;</span> <span class="op">=</span> <span class="ident">OnceBox::new</span>();

        <span class="ident">SEEDS</span>.<span class="ident">get_or_init</span>(<span class="op">|</span><span class="op">|</span> {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">result</span>: [<span class="ident">u8</span>; <span class="number">64</span>] <span class="op">=</span> [<span class="number">0</span>; <span class="number">64</span>];
            <span class="ident">getrandom::getrandom</span>(<span class="kw-2">&amp;mut</span> <span class="ident">result</span>).<span class="ident">expect</span>(<span class="string">&quot;getrandom::getrandom() failed.&quot;</span>);
            <span class="ident">Box::new</span>(<span class="ident">result</span>.<span class="ident">convert</span>())
        })
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;compile-time-rng&quot;</span>, <span class="ident">any</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;runtime-rng&quot;</span>), <span class="ident">test</span>)))]</span>
    <span class="kw">fn</span> <span class="ident">get_fixed_seeds</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> [[<span class="ident">u64</span>; <span class="number">4</span>]; <span class="number">2</span>] {
        <span class="kw">const</span> <span class="ident">RAND</span>: [[<span class="ident">u64</span>; <span class="number">4</span>]; <span class="number">2</span>] <span class="op">=</span> [
            [
                <span class="macro">const_random!</span>(<span class="ident">u64</span>),
                <span class="macro">const_random!</span>(<span class="ident">u64</span>),
                <span class="macro">const_random!</span>(<span class="ident">u64</span>),
                <span class="macro">const_random!</span>(<span class="ident">u64</span>),
            ], [
                <span class="macro">const_random!</span>(<span class="ident">u64</span>),
                <span class="macro">const_random!</span>(<span class="ident">u64</span>),
                <span class="macro">const_random!</span>(<span class="ident">u64</span>),
                <span class="macro">const_random!</span>(<span class="ident">u64</span>),
            ]
        ];
        <span class="kw-2">&amp;</span><span class="ident">RAND</span>
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;runtime-rng&quot;</span>), <span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;compile-time-rng&quot;</span>)))]</span>
    <span class="kw">fn</span> <span class="ident">get_fixed_seeds</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> [[<span class="ident">u64</span>; <span class="number">4</span>]; <span class="number">2</span>] {
        <span class="kw-2">&amp;</span>[<span class="ident">PI</span>, <span class="ident">PI2</span>]
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;none&quot;</span>)))]</span>
    <span class="kw">fn</span> <span class="ident">gen_hasher_seed</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="kw">let</span> <span class="ident">stack</span> <span class="op">=</span> <span class="self">self</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="kw">_</span> <span class="kw">as</span> <span class="ident">usize</span>;
        <span class="self">self</span>.<span class="ident">counter</span>.<span class="ident">fetch_add</span>(<span class="ident">stack</span>, <span class="ident">Ordering::Relaxed</span>)
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;none&quot;</span>))]</span>
    <span class="kw">fn</span> <span class="ident">gen_hasher_seed</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="kw">let</span> <span class="ident">stack</span> <span class="op">=</span> <span class="self">self</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="kw">_</span> <span class="kw">as</span> <span class="ident">usize</span>;
        <span class="kw">let</span> <span class="ident">previous</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">counter</span>.<span class="ident">load</span>(<span class="ident">Ordering::Relaxed</span>);
        <span class="kw">let</span> <span class="ident">new</span> <span class="op">=</span> <span class="ident">previous</span>.<span class="ident">wrapping_add</span>(<span class="ident">stack</span>);
        <span class="self">self</span>.<span class="ident">counter</span>.<span class="ident">store</span>(<span class="ident">new</span>, <span class="ident">Ordering::Relaxed</span>);
        <span class="ident">new</span>
    }
}

<span class="doccomment">/// Provides a [Hasher] factory. This is typically used (e.g. by [HashMap]) to create</span>
<span class="doccomment">/// [AHasher]s in order to hash the keys of the map. See `build_hasher` below.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [build_hasher]: ahash::</span>
<span class="doccomment">/// [Hasher]: std::hash::Hasher</span>
<span class="doccomment">/// [BuildHasher]: std::hash::BuildHasher</span>
<span class="doccomment">/// [HashMap]: std::collections::HashMap</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">RandomState</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">k0</span>: <span class="ident">u64</span>,
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">k1</span>: <span class="ident">u64</span>,
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">k2</span>: <span class="ident">u64</span>,
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">k3</span>: <span class="ident">u64</span>,
}

<span class="kw">impl</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">RandomState</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="ident">f</span>.<span class="ident">pad</span>(<span class="string">&quot;RandomState { .. }&quot;</span>)
    }
}

<span class="kw">impl</span> <span class="ident">RandomState</span> {

    <span class="doccomment">/// Provides an optional way to manually supply a source of randomness for Hasher keys.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The provided [RandomSource] will be used to be used as a source of randomness by [RandomState] to generate new states.</span>
    <span class="doccomment">/// If this method is not invoked the standard source of randomness is used as described in the Readme.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The source of randomness can only be set once, and must be set before the first RandomState is created.</span>
    <span class="doccomment">/// If the source has already been specified `Err` is returned with a `bool` indicating if the set failed because</span>
    <span class="doccomment">/// method was previously invoked (true) or if the default source is already being used (false).</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;none&quot;</span>)))]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_random_source</span>(<span class="ident">source</span>: <span class="kw">impl</span> <span class="ident">RandomSource</span> <span class="op">+</span> <span class="ident">Send</span> <span class="op">+</span> <span class="ident">Sync</span> <span class="op">+</span> <span class="lifetime">&#39;static</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">bool</span><span class="op">&gt;</span> {
        <span class="ident">RAND_SOURCE</span>.<span class="ident">set</span>(<span class="ident">Box::new</span>(<span class="ident">Box::new</span>(<span class="ident">source</span>))).<span class="ident">map_err</span>(<span class="op">|</span><span class="ident">s</span><span class="op">|</span> <span class="ident">s</span>.<span class="ident">as_ref</span>().<span class="ident">type_id</span>() <span class="op">!</span><span class="op">=</span> <span class="ident">TypeId::of</span>::<span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">DefaultRandomSource</span><span class="op">&gt;</span>())
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;none&quot;</span>)))]</span>
    <span class="kw">fn</span> <span class="ident">get_src</span>() -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="kw">dyn</span> <span class="ident">RandomSource</span> {
        <span class="ident">RAND_SOURCE</span>.<span class="ident">get_or_init</span>(<span class="op">|</span><span class="op">|</span> <span class="ident">Box::new</span>(<span class="ident">Box::new</span>(<span class="ident">DefaultRandomSource::new</span>()))).<span class="ident">as_ref</span>()
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;none&quot;</span>))]</span>
    <span class="kw">fn</span> <span class="ident">get_src</span>() -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="kw">dyn</span> <span class="ident">RandomSource</span> {
        <span class="kw">static</span> <span class="ident">RAND_SOURCE</span>: <span class="ident">DefaultRandomSource</span> <span class="op">=</span> <span class="ident">DefaultRandomSource::default</span>();
        <span class="kw-2">&amp;</span><span class="ident">RAND_SOURCE</span>
    }

    <span class="doccomment">/// Use randomly generated keys</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="ident">RandomState</span> {
        <span class="kw">let</span> <span class="ident">src</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::get_src</span>();
        <span class="kw">let</span> <span class="ident">fixed</span> <span class="op">=</span> <span class="ident">src</span>.<span class="ident">get_fixed_seeds</span>();
        <span class="ident"><span class="self">Self</span>::from_keys</span>(<span class="kw-2">&amp;</span><span class="ident">fixed</span>[<span class="number">0</span>], <span class="kw-2">&amp;</span><span class="ident">fixed</span>[<span class="number">1</span>], <span class="ident">src</span>.<span class="ident">gen_hasher_seed</span>())
    }

    <span class="doccomment">/// Allows for supplying seeds, but each time it is called the resulting state will be different.</span>
    <span class="doccomment">/// This is done using a static counter, so it can safely be used with a fixed keys.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">generate_with</span>(<span class="ident">k0</span>: <span class="ident">u64</span>, <span class="ident">k1</span>: <span class="ident">u64</span>, <span class="ident">k2</span>: <span class="ident">u64</span>, <span class="ident">k3</span>: <span class="ident">u64</span>) -&gt; <span class="ident">RandomState</span> {
        <span class="kw">let</span> <span class="ident">src</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::get_src</span>();
        <span class="kw">let</span> <span class="ident">fixed</span> <span class="op">=</span> <span class="ident">src</span>.<span class="ident">get_fixed_seeds</span>();
        <span class="ident">RandomState::from_keys</span>(<span class="kw-2">&amp;</span><span class="ident">fixed</span>[<span class="number">0</span>], <span class="kw-2">&amp;</span>[<span class="ident">k0</span>, <span class="ident">k1</span>, <span class="ident">k2</span>, <span class="ident">k3</span>], <span class="ident">src</span>.<span class="ident">gen_hasher_seed</span>())
    }

    <span class="kw">fn</span> <span class="ident">from_keys</span>(<span class="ident">a</span>: <span class="kw-2">&amp;</span>[<span class="ident">u64</span>; <span class="number">4</span>], <span class="ident">b</span>: <span class="kw-2">&amp;</span>[<span class="ident">u64</span>; <span class="number">4</span>], <span class="ident">c</span>: <span class="ident">usize</span>) -&gt; <span class="ident">RandomState</span> {
        <span class="kw">let</span> <span class="kw-2">&amp;</span>[<span class="ident">k0</span>, <span class="ident">k1</span>, <span class="ident">k2</span>, <span class="ident">k3</span>] <span class="op">=</span> <span class="ident">a</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">hasher</span> <span class="op">=</span> <span class="ident">AHasher::from_random_state</span>(<span class="kw-2">&amp;</span><span class="ident">RandomState</span> { <span class="ident">k0</span>, <span class="ident">k1</span>, <span class="ident">k2</span>, <span class="ident">k3</span> });
        <span class="ident">hasher</span>.<span class="ident">write_usize</span>(<span class="ident">c</span>);
        <span class="kw">let</span> <span class="ident">mix</span> <span class="op">=</span> <span class="op">|</span><span class="ident">k</span>: <span class="ident">u64</span><span class="op">|</span> {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">h</span> <span class="op">=</span> <span class="ident">hasher</span>.<span class="ident">clone</span>();
            <span class="ident">h</span>.<span class="ident">write_u64</span>(<span class="ident">k</span>);
            <span class="ident">h</span>.<span class="ident">finish</span>()
        };
        <span class="ident">RandomState</span> {
            <span class="ident">k0</span>: <span class="ident">mix</span>(<span class="ident">b</span>[<span class="number">0</span>]),
            <span class="ident">k1</span>: <span class="ident">mix</span>(<span class="ident">b</span>[<span class="number">1</span>]),
            <span class="ident">k2</span>: <span class="ident">mix</span>(<span class="ident">b</span>[<span class="number">2</span>]),
            <span class="ident">k3</span>: <span class="ident">mix</span>(<span class="ident">b</span>[<span class="number">3</span>]),
        }
    }

    <span class="doccomment">/// Internal. Used by Default.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">with_fixed_keys</span>() -&gt; <span class="ident">RandomState</span> {
        <span class="kw">let</span> [<span class="ident">k0</span>, <span class="ident">k1</span>, <span class="ident">k2</span>, <span class="ident">k3</span>] <span class="op">=</span> <span class="ident"><span class="self">Self</span>::get_src</span>().<span class="ident">get_fixed_seeds</span>()[<span class="number">0</span>];
        <span class="ident">RandomState</span> { <span class="ident">k0</span>, <span class="ident">k1</span>, <span class="ident">k2</span>, <span class="ident">k3</span> }
    }

    <span class="doccomment">/// Allows for explicitly setting a seed to used.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note: This method does not require the provided seed to be strong.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">with_seed</span>(<span class="ident">key</span>: <span class="ident">usize</span>) -&gt; <span class="ident">RandomState</span> {
        <span class="kw">let</span> <span class="ident">fixed</span> <span class="op">=</span> <span class="ident"><span class="self">Self</span>::get_src</span>().<span class="ident">get_fixed_seeds</span>();
        <span class="ident">RandomState::from_keys</span>(<span class="kw-2">&amp;</span><span class="ident">fixed</span>[<span class="number">0</span>], <span class="kw-2">&amp;</span><span class="ident">fixed</span>[<span class="number">1</span>], <span class="ident">key</span>)
    }

    <span class="doccomment">/// Allows for explicitly setting the seeds to used.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note: This method is robust against 0s being passed for one or more of the parameters</span>
    <span class="doccomment">/// or the same value being passed for more than one parameter.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">with_seeds</span>(<span class="ident">k0</span>: <span class="ident">u64</span>, <span class="ident">k1</span>: <span class="ident">u64</span>, <span class="ident">k2</span>: <span class="ident">u64</span>, <span class="ident">k3</span>: <span class="ident">u64</span>) -&gt; <span class="ident">RandomState</span> {
        <span class="ident">RandomState</span> { <span class="ident">k0</span>: <span class="ident">k0</span> <span class="op">^</span> <span class="ident">PI2</span>[<span class="number">0</span>], <span class="ident">k1</span>: <span class="ident">k1</span> <span class="op">^</span> <span class="ident">PI2</span>[<span class="number">1</span>], <span class="ident">k2</span>: <span class="ident">k2</span> <span class="op">^</span> <span class="ident">PI2</span>[<span class="number">2</span>], <span class="ident">k3</span>: <span class="ident">k3</span> <span class="op">^</span> <span class="ident">PI2</span>[<span class="number">3</span>] }
    }
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">RandomState</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::new</span>()
    }
}

<span class="kw">impl</span> <span class="ident">BuildHasher</span> <span class="kw">for</span> <span class="ident">RandomState</span> {
    <span class="kw">type</span> <span class="ident">Hasher</span> <span class="op">=</span> <span class="ident">AHasher</span>;

    <span class="doccomment">/// Constructs a new [AHasher] with keys based on this [RandomState] object.</span>
    <span class="doccomment">/// This means that two different [RandomState]s will will generate</span>
    <span class="doccomment">/// [AHasher]s that will return different hashcodes, but [Hasher]s created from the same [BuildHasher]</span>
    <span class="doccomment">/// will generate the same hashes for the same input data.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use ahash::{AHasher, RandomState};</span>
    <span class="doccomment">/// use std::hash::{Hasher, BuildHasher};</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let build_hasher = RandomState::new();</span>
    <span class="doccomment">/// let mut hasher_1 = build_hasher.build_hasher();</span>
    <span class="doccomment">/// let mut hasher_2 = build_hasher.build_hasher();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// hasher_1.write_u32(1234);</span>
    <span class="doccomment">/// hasher_2.write_u32(1234);</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// assert_eq!(hasher_1.finish(), hasher_2.finish());</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let other_build_hasher = RandomState::new();</span>
    <span class="doccomment">/// let mut different_hasher = other_build_hasher.build_hasher();</span>
    <span class="doccomment">/// different_hasher.write_u32(1234);</span>
    <span class="doccomment">/// assert_ne!(different_hasher.finish(), hasher_1.finish());</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// [Hasher]: std::hash::Hasher</span>
    <span class="doccomment">/// [BuildHasher]: std::hash::BuildHasher</span>
    <span class="doccomment">/// [HashMap]: std::collections::HashMap</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">build_hasher</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">AHasher</span> {
        <span class="ident">AHasher::from_random_state</span>(<span class="self">self</span>)
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;specialize&quot;</span>)]</span>
<span class="kw">impl</span> <span class="ident">BuildHasherExt</span> <span class="kw">for</span> <span class="ident">RandomState</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">hash_as_u64</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Hash</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">value</span>: <span class="kw-2">&amp;</span><span class="ident">T</span>) -&gt; <span class="ident">u64</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">hasher</span> <span class="op">=</span> <span class="ident">AHasherU64</span> {
            <span class="ident">buffer</span>: <span class="self">self</span>.<span class="ident">k0</span>,
            <span class="ident">pad</span>: <span class="self">self</span>.<span class="ident">k1</span>,
        };
        <span class="ident">value</span>.<span class="ident">hash</span>(<span class="kw-2">&amp;mut</span> <span class="ident">hasher</span>);
        <span class="ident">hasher</span>.<span class="ident">finish</span>()
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">hash_as_fixed_length</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Hash</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">value</span>: <span class="kw-2">&amp;</span><span class="ident">T</span>) -&gt; <span class="ident">u64</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">hasher</span> <span class="op">=</span> <span class="ident">AHasherFixed</span>(<span class="self">self</span>.<span class="ident">build_hasher</span>());
        <span class="ident">value</span>.<span class="ident">hash</span>(<span class="kw-2">&amp;mut</span> <span class="ident">hasher</span>);
        <span class="ident">hasher</span>.<span class="ident">finish</span>()
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">hash_as_str</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Hash</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">value</span>: <span class="kw-2">&amp;</span><span class="ident">T</span>) -&gt; <span class="ident">u64</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">hasher</span> <span class="op">=</span> <span class="ident">AHasherStr</span>(<span class="self">self</span>.<span class="ident">build_hasher</span>());
        <span class="ident">value</span>.<span class="ident">hash</span>(<span class="kw-2">&amp;mut</span> <span class="ident">hasher</span>);
        <span class="ident">hasher</span>.<span class="ident">finish</span>()
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_unique</span>() {
        <span class="kw">let</span> <span class="ident">a</span> <span class="op">=</span> <span class="ident">RandomState::new</span>();
        <span class="kw">let</span> <span class="ident">b</span> <span class="op">=</span> <span class="ident">RandomState::new</span>();
        <span class="macro">assert_ne!</span>(<span class="ident">a</span>.<span class="ident">build_hasher</span>().<span class="ident">finish</span>(), <span class="ident">b</span>.<span class="ident">build_hasher</span>().<span class="ident">finish</span>());
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;runtime-rng&quot;</span>, <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;compile-time-rng&quot;</span>, <span class="ident">test</span>))))]</span>
    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_not_pi</span>() {
        <span class="macro">assert_ne!</span>(<span class="ident">PI</span>, <span class="ident">RandomState::get_src</span>().<span class="ident">get_fixed_seeds</span>()[<span class="number">0</span>]);
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;compile-time-rng&quot;</span>, <span class="ident">any</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;runtime-rng&quot;</span>), <span class="ident">test</span>)))]</span>
    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_not_pi_const</span>() {
        <span class="macro">assert_ne!</span>(<span class="ident">PI</span>, <span class="ident">RandomState::get_src</span>().<span class="ident">get_fixed_seeds</span>()[<span class="number">0</span>]);
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;runtime-rng&quot;</span>), <span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;compile-time-rng&quot;</span>)))]</span>
    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_pi</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">PI</span>, <span class="ident">RandomState::get_src</span>().<span class="ident">get_fixed_seeds</span>()[<span class="number">0</span>]);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_with_seeds_const</span>() {
        <span class="kw">const</span> <span class="ident">_CONST_RANDOM_STATE</span>: <span class="ident">RandomState</span> <span class="op">=</span> <span class="ident">RandomState::with_seeds</span>(<span class="number">17</span>, <span class="number">19</span>, <span class="number">21</span>, <span class="number">23</span>);
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="ahash" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>